{******************************************************************************}
{	RnnLib  Components                                                     }
{                                                                              }
{ RnnDos                                                                       }
{ Copyright (c) 1998-1999 Michael Rynn                                         }
{                                                                              }
{******************************************************************************}
unit JvRnnDos;
interface
Uses JvRnnScCst, Classes, SysUtils, JvDirList;
{$IFDEF WIN32}
{$DEFINE PROCESSCTL}
{$ENDIF}
type
  EJvDosCmd = class(EJvRnnScript);
{script procedures}
{@DOS_RUN  exefile args}
{@DOS_KILL    exefile exitcode}
{@DOS_ATTRIB [+r|-r] [+a|-a] [+s|-s] [+h|-h] <file>}
{@DOS_DATETIME [format=="yyyy/M/d hh:mm:ss"] [stamp==]<datestring>  [file==]<file>
{@DOS_XCOPY <source path> <destinaction path>
{@DOS_COPY <source> <destination>}
{@DOS_DEL  <file(s) specification>}
{@DOS_RENAME <oldname> <newname>}
{@DOS_DELTREE <directory path>}
{@DOS_MKDIR <directory path>}
{@FOR_FILES <var_name> "*.* | ;*.ext" in <directory> ..... @END_FOR_FILES}
{script functions}
{FILE_HAS_ATTRIBUTES(normal,archive, hidden, sysfile, readonly) : 'Y' | 'N'}
{DIR_EXISTS(<directory path>)}

const
  kDosCopy = 'DOS_COPY';
  kDosXCopy = 'DOS_XCOPY';
  kDosDel = 'DOS_DEL';
  kDosRename = 'DOS_RENAME';
  kDosWallpaper = 'DOS_WALLPAPER';
  kDosDelTree = 'DOS_DELTREE';
  kDosMkDir = 'DOS_MKDIR';
  kFilesAllExist = 'FILES_ALL_EXIST';
  kDirectorysExist = 'DIRECTORYS_EXIST';
  kForFiles = 'FOR_FILES';
  kEndForFiles = 'END_FOR_FILES';
  kDosDateTime = 'DOS_DATETIME';
  kDosAttr = 'DOS_ATTRIB';
  kDosRun = 'DOS_RUN';
  kDosKill = 'DOS_KILL';
  kDosBatch = 'DOS_BATCH';
  kfaArchive = 'faArchive';
  kfaHidden = 'faHidden';
  kfaSysFile = 'faSysFile';
  kfaReadOnly = 'faReadOnly';
  kfaNormal = 'faNormal';

procedure InstallDOSCmds(scriptor:TJvRnnCustomScript);


implementation
Uses
  JvRnnPars, FileCtrl, JvCCArray,
  WinProcs, WinTypes, ShellAPI,
  {$IFDEF PROCESSCTL} JvRnnProLs, JvRnnXProc,{$ENDIF}
  JvRnnVarCp, JvRnnStrUt, Forms, Dialogs,JvSplatFile, JvRnnLogTx;

function ToUpper(inChar:Char) : Char;
begin
  if (ORD(inChar) >= ORD('a')) and (ORD(inChar) <= ORD('z')) then
    Result := CHAR(ORD(inChar) - ORD('a') + ORD('A'))
  else
    Result := inChar;
end;
(*
function nextargoption(
  var p : PChar;
  var token : string;
  var isOption : boolean;
  var ptype : TJvRnnParenType) : boolean;
begin
  Result := StrNextToken(p,token,ptype);
  if Length(token) > 2 then
  begin
    isOption := (Pos('--',token) = 1);
    if isOption then
      token := Copy(token,3,Length(token)-2);
    if not isOption then
    begin
      isOption := (Pos('/',token) = 1);
      if isOption then
        token := Copy(token,2,Length(token)-1);
    end;
  end;
end;*)


{---------------DOS like functions -------------------}

function GetFileAttrBitmask(const sc : char) : integer;
begin
  CASE sc of
  'a':Result := faArchive;
  'r':Result := faReadOnly;
  's':Result := faSysFile;
  'h':Result := faHidden;
  ELSE
    Result := 0;
  end;
end;

procedure DosCopy_F(data:Pointer); far; forward;
procedure DosXCopy_F(data:Pointer); far; forward;
procedure DosDel_F(data:Pointer); far; forward;
procedure DosRename_F(data:Pointer); far; forward;
procedure DosDelTree_F(data:Pointer); far; forward;
procedure DosMkDir_F(data:Pointer); far; forward;
procedure ForFiles_F(data:Pointer);far;forward;
procedure EndForFiles_F(data:Pointer);far;forward;
procedure DosAttr_F(data:Pointer);far;forward;
procedure DosSetDateTime_F(data:Pointer);far;forward;
procedure DosBatch_F(data:Pointer);far;forward;


procedure DosRun_F(data:Pointer); far; forward;
{$IFDEF PROCESSCTL}
procedure DosWallPaper_F(data:Pointer);  far; forward;
procedure DosKill_F(data:Pointer); far; forward;
{$ENDIF}

function  FilesAllExist_F(
  sct: TJvRnnCustomScript; args : TStrings) : string; far; forward;
function  DirectorysExist_F(
  sct: TJvRnnCustomScript; args : TStrings) : string;  far; forward;

type
  TForFilesObj = class(TJvRnnScrObj)
    itdir : TSrcTreeIterator;
    var_name : string;
    old_var_value : string;
    has_old_value : boolean;

    procedure AfterPopState(var rst:TJvRnnScriptState); override;
    destructor Destroy; override;
  end;


procedure TForFilesObj.AfterPopState(var rst:TJvRnnScriptState);
begin
  with rst do
  begin
    script.free;
    script := nil;
  end;
end;

destructor TForFilesObj.Destroy;
begin
  itdir.free;
  inherited Destroy;
end;


procedure ForFiles_F(data:Pointer);
const
  kForSyntax = '@FOR_FILES <var_name> "*.* | ;*.ext" [in|recurse] <directory> ..... @END_FOR_FILES';
var

  cmdInfo : PJvScriptCmdInfo;
  p, r : PChar;
  varray : TJvCCStrStrArray;
  scriptor : TJvRnnCustomScript;
  token : string;
  xtoken : string;
  var_name : string;
  old_value : string;
  filters : string;
  directory : string;
  has_old_value : boolean;
  do_recurse  : boolean;
  ptype : TJvRnnParenType;
  tokentype : TJvRnnTokenType;
  vix : integer;
  dct : integer;
  saveState : TJvRnnScriptState;
  pushState : TJvRnnScriptState;
  dirff : TForFilesObj;
  info : TFileInfo;
  newscript : TStrings;
  dirlist : TSourceDir;
  itdir : TSrcTreeIterator;

  procedure throw_error(const instr:string);
  begin
    raise EJvRnnScript.create(kForSyntax + instr);
  end;

  procedure next_string;
  begin
    if not StrNextToken(p,token,ptype) then
      throw_error('token missing');
  end;

  procedure sub_next;
  begin
    if not StrNextTokenType(p,token,ptype,tokentype) then
      throw_error('token missing');
  end;
begin
  cmdInfo := PJvScriptCmdInfo(data);
  scriptor := cmdInfo^.scriptor;
  varray := scriptor.Variables;
  p := cmdInfo^.cmdcstr;

  sub_next;  {get variable name}
  var_name := token;
  vix := varray.IndexOf(var_name);
  has_old_value := (vix >= 0);
  if has_old_value then
    old_value := varray.GetIndexValue(vix);

  next_string; {get filter}

  filters := token;
  do_recurse := FALSE;
  if  (COMPARETEXT('in',token)=0) then
    do_recurse := FALSE
  else if  (COMPARETEXT('recurse',token)=0) then
    do_recurse := TRUE
  else
     throw_error('missing "in | recurse"');

  {get directory path}
  next_string;
  directory := token;
  saveState := scriptor.GetScriptState; {get a copy of script state}
  dct := 1;
  newscript := TStringList.create;
  InitializeScriptState(pushState);
  pushState.script := saveState.script;

  try
    {interpret succeeding lines until find ENDFOR;
    problem is succeeding lines may contain
    text that contains 'ENDFOR'}
    with saveState do
    Repeat
      if (lineNum >= script.count) then
        break;
      xtoken := script[lineNum];
      r := StrToPChar(xtoken);
      {test if line starts with a @FOR}
      r := StrStartToken(r);
      if (r^ = '@') then
      begin
        if StrNextTokenType(r,token, ptype, tokentype) then
        begin
          if COMPARETEXT(token,kForFiles)=0 then
            Inc(dct);
        end;
      end
      else if (r^<>#0)then
      begin
        if StrNextTokenType(r,token, ptype, tokentype) then
        begin
          if COMPARETEXT(token,kEndForFiles)=0 then
          begin
            if (StrNextTokenType(r,token, ptype, tokentype)) and (token=';') then
            begin
              Dec(dct);
              if (dct) = 0 then
              begin
                Inc(linenum);  {ENDFOR is not executed}
                break;
              end;
            end;
          end;
        end;
      end;
      newscript.Add(xtoken);
      Inc(lineNum);
    Until(dct = 0);
    scriptor.SetScriptState(saveState); {ready for resumption}
    dirlist := CreateDirList(nil,directory, filters, do_recurse);
    itdir :=  TSrcTreeIterator.Create(dirlist);
    if not itdir.FirstFile(info) then
    begin
      newscript.free;
      newscript := nil;
    end else
    begin
      varray.SetVariable(var_name, itdir.FileName);
      dirff := TForFilesObj.create;
      dirff.itdir := itdir;
      dirff.var_name := var_name;
      dirff.old_var_value := old_value;
      dirff.has_old_value := has_old_value;
      WITH pushState do
      begin
        script := newscript;
        ownerid := 'FOR_FILES';
        refptr := dirff;
      end;
      scriptor.PushScriptState(pushState);
    end;
  except
    newscript.free;
    raise;
  end;
end;

procedure EndForFiles_F(data:Pointer);
var
  cmdInfo : PJvScriptCmdInfo;
  scriptor : TJvRnnCustomScript;
begin
  cmdInfo := PJvScriptCmdInfo(data);
  scriptor := cmdInfo^.scriptor;
   scriptor.PopScriptState;
end;

procedure DosXCopy_F(data:Pointer);
var
  cmdInfo : PJvScriptCmdInfo;
  p : PChar;
  token : string;
  ptype : TJvRnnParenType;
  srcname : string;
  destname : string;
  gotSource : boolean;
  gotDest : boolean;
  option : Char;
  recurse : boolean;
  splaton : integer;
  {
  @DOS_XCOPY /S [src] [dest]

  [src] --> [drive:] [path] [/*.*]   ; copy subtree of source to subtree of dest
  [dest] -->  [drive:] [path]
  }

  function nextarg : boolean;
  begin
    Result := StrNextToken(p,token,ptype);
    if Result then
      Result := (length(token) > 0);
  end;

  procedure ThrowError(const s : string);
  begin
    raise EJvDosCmd.create('DOS_COPY: '+s);
  end;

begin
  cmdInfo := PJvScriptCmdInfo(data);
  p := cmdInfo^.cmdcstr;
  gotSource := FALSE;
  gotDest := FALSE;
  recurse := FALSE;
  while nextarg do
  begin
    if (token[1] = '\') then
    begin
      if (Length(token) <= 1) then
        ThrowError('Option ?');
      option := ToUpper(token[2]);
      CASE option of
      'S' : recurse := TRUE;
      ELSE
        ThrowError('Unknown option '+token);
      END;
    end
    else begin
      if not gotSource then
      begin
        gotSource := TRUE;
        srcname := token;
      end else
      if not gotDest then
      begin
        gotDest := TRUE;
        destname := token;
      end else
        ThrowError('Excess arguments');
    end;
  end;
  token := ExtractFileDir(destname);
  if not DirectoryExists(token) then
    ForceDirectories(token);
  splaton := kALL_CONDITIONS;
  DoSplatDirectory(srcName, destName, nil, splaton, recurse);
end;

procedure DosCopy_F(data:Pointer);
var
  cmdInfo : PJvScriptCmdInfo;
  p : PChar;
  token : string;
  ptype : TJvRnnParenType;
  srcname : string;
  destname : string;

  function nextarg : boolean;
  begin
    Result := StrNextToken(p,token,ptype);
  end;

  procedure ThrowError(const s : string);
  begin
    raise EJvDosCmd.create('DOS_COPY: '+s);
  end;
begin

  cmdInfo := PJvScriptCmdInfo(data);
  p := cmdInfo^.cmdcstr;

  if not nextarg then
    ThrowError('source name expected');
  srcname := token;

  if not nextarg then
    ThrowError('destination name expected');
  if not FileExists(srcname) then
    ThrowError(srcname+' not found');
  destname := token;
  token := ExtractFileDir(destname);
  if not DirectoryExists(token) then
    ForceDirectories(token);
  DoSplatFile(srcName, destName, nil);
end;

procedure DosDel_F(data:Pointer);
var
  cmdInfo : PJvScriptCmdInfo;
  p : PChar;
  token : string;
  ptype : TJvRnnParenType;

  function nextarg : boolean;
  begin
    Result := StrNextToken(p,token,ptype);
  end;

  procedure ThrowError(const s : string);
  begin
    raise EJvDosCmd.create('DOS_DEL: '+s);
  end;
begin
  cmdInfo := PJvScriptCmdInfo(data);
  p := cmdInfo^.cmdcstr;

  if not nextarg then
    ThrowError('file(s) specification expected');

  DeleteFileMask(token);
end;

procedure DosRename_F(data:Pointer);
var
  cmdInfo : PJvScriptCmdInfo;
  p : PChar;
  token : string;
  ptype : TJvRnnParenType;
  oldname : string;

  function nextarg : boolean;
  begin
    Result := StrNextToken(p,token,ptype);
  end;

  procedure ThrowError(const s : string);
  begin
    raise EJvDosCmd.create('DOS_RENAME: '+s);
  end;

  procedure ThrowSyntaxError;
  begin
    ThrowError('File1 File2;');
  end;

begin
  cmdInfo := PJvScriptCmdInfo(data);
  p := cmdInfo^.cmdcstr;

  if not nextarg then
    ThrowSyntaxError;
  oldname := token;
  if not nextarg then
    ThrowSyntaxError;

  if not (RenameFile(oldname, token)) then
    ThrowError(Format('Could not rename %s as %s',[oldname, token]));
end;

procedure DosDelTree_F(data:Pointer);
var
  cmdInfo : PJvScriptCmdInfo;
  p : PChar;
  token : string;
  ptype : TJvRnnParenType;

  function nextarg : boolean;
  begin
    Result := StrNextToken(p,token,ptype);
  end;

  procedure ThrowError(const s : string);
  begin
    raise EJvDosCmd.create('DOS_DELTREE: '+s);
  end;

begin
  cmdInfo := PJvScriptCmdInfo(data);
  p := cmdInfo^.cmdcstr;
  if not nextarg then
    ThrowError('directory path expected');
  DeleteDirTree(token);
end;

procedure DosMkDir_F(data:Pointer);
var
  cmdInfo : PJvScriptCmdInfo;
  p : PChar;
  token : string;
  ptype : TJvRnnParenType;

  function nextarg : boolean;
  begin
    Result := StrNextToken(p,token,ptype);
  end;

  procedure ThrowError(const s : string);
  begin
    raise EJvDosCmd.create('DOS_MKDIR: '+s);
  end;

begin
  cmdInfo := PJvScriptCmdInfo(data);
  p := cmdInfo^.cmdcstr;
  if not nextarg then
    ThrowError('directory path expected');
  if not DirectoryExists(token) then
    ForceDirectories(token);
end;

procedure DosBatch_F(data:Pointer);
var
  cmdInfo : PJvScriptCmdInfo;
  p : PChar;
  token : string;
  filename : string;
  ptype : TJvRnnParenType;
  defdir : string;
  gotFileName : boolean;
  isOption : boolean;

  function nextarg : boolean;
  begin
    Result := StrNextToken(p,token,ptype);
    if Length(token) > 2 then
    begin
      isOption := (Pos('--',token) = 1);
      if isOption then
        token := Copy(token,3,Length(token)-2);
      if not isOption then
      begin
        isOption := (Pos('/',token) = 1);
        if isOption then
          token := Copy(token,2,Length(token)-1);
      end;
    end;
  end;

  procedure ThrowError(const s : string);
  begin
    raise EJvDosCmd.create('DOS_RUN '+s);
  end;

  procedure ErrNoFile;
  begin
    ThrowError('<FileName> args');
  end;

begin
  {first line = DOS_BATCH
    succeeding lines
    dos commands without a ';'
  }
  cmdInfo := PJvScriptCmdInfo(data);
  p := cmdInfo^.cmdcstr;
  gotFileName := FALSE;
  defDir := '';
  while nextarg do
  begin
    if isOption then
    begin
      ThrowError('Unknown option: '+token);
    end else
    begin
      if (not FileExists(token)) then
        ThrowError(Format(': File %s not found',[token]));
      filename := token;
      break;
    end;
  end;
  if (not gotFileName) then
    ErrNoFile;
  ShellExecute(Application.Handle,nil,StrToPChar(filename),p,
    StrToPChar(defDir),SW_SHOWNORMAL);
end;

procedure DosRun_F(data:Pointer);
var
  cmdInfo : PJvScriptCmdInfo;
  p : PChar;
  token : string;
  ptype : TJvRnnParenType;
  defdir : string;
  {$IFDEF PROCESSCTL}
  process : TJvRnnXProcess;
  {$ENDIF}
  doWait : boolean;
  isOption : boolean;
 
  function nextarg : boolean;
  begin
    Result := StrNextToken(p,token,ptype);
    if Length(token) > 2 then
      isOption := (Pos('--',token) = 1);
  end;

  procedure ThrowError(const s : string);
  begin
    raise EJvDosCmd.create('DOS_RUN '+s);
  end;

  procedure ErrNoFile;
  begin
    ThrowError('[--wait] <FileName>');
  end;

begin
  cmdInfo := PJvScriptCmdInfo(data);
  p := cmdInfo^.cmdcstr;
  doWait := FALSE;
  defDir := '';
  while (nextarg and isOption) do
  begin
    token := Copy(token,3,Length(token)-2);
    if (COMPARETEXT('WAIT',token) = 0) then
    begin
      doWait := TRUE;
    end
    else if (COMPARETEXT('DIR',token) = 0) then
    begin
      if (not nextarg) or (IsOption) then
        ThrowError('no directory');
      defdir := token;
    end;
  end;
  {first non-option is the file}
  if Length(defdir) = 0 then
    defdir := 'C:\DOS';
  if (not FileExists(token)) then
    ThrowError(Format(': File %s not found',[token]));

  {$IFDEF PROCESSCTL}
  process := TJvRnnXProcess.Create(nil);
  try
    process.CommandLine := token + ' ' + string(p);
    process.WaitTillExit := doWait;
    process.UseThread := FALSE;
    process.Running := TRUE;
  finally
    process.free;
  end;
  {$ELSE}
  ShellExecute(Application.Handle,nil,StrToPChar(token),p,
        StrToPChar(defDir),SW_SHOWNORMAL);
  {$ENDIF}
end;
{$IFDEF PROCESSCTL}

procedure DosWallPaper_F(data:Pointer);
var
  cmdInfo : PJvScriptCmdInfo;
  p : PChar;
  token : string;
  ptype : TJvRnnParenType;

  function nextarg : boolean;
  begin
    Result := StrNextToken(p,token,ptype);
  end;
  procedure ErrNoFile;
  begin
    raise EJvRnnScript.create('DOS_WALLPAPER <Bitmap filename>');
  end;
  
begin
  cmdInfo := PJvScriptCmdInfo(data);
  p := cmdInfo^.cmdcstr;
  if (not nextarg) then
    ErrNoFile;
  SystemParametersInfo(SPI_SETDESKWALLPAPER,0,PChar(token), SPIF_UPDATEINIFILE);
end;

procedure DosKill_F(data:Pointer);
var
  cmdInfo : PJvScriptCmdInfo;
  p : PChar;
  token : string;
  ptype : TJvRnnParenType;
  plist : TJvRnnProcessList;
  pe : PRnnProcEntry;
  path : string;
  nofail : boolean;
  done : boolean;

  function nextarg : boolean;
  begin
    Result := StrNextToken(p,token,ptype);
  end;

  procedure ThrowError(const s : string);
  begin
    raise EJvDosCmd.create('DOS_KILL '+s);
  end;

  procedure ErrNoFile;
  begin
    ThrowError('<FileName>');
  end;

begin
  cmdInfo := PJvScriptCmdInfo(data);
  p := cmdInfo^.cmdcstr;
  if (not nextarg) then
    ErrNoFile;
  nofail := (token = '--nofail');
  if (nofail) and (not nextarg) then
    ErrNoFile;
  path := ExtractFileDir(token);
  plist := GetRnnProcessList;
  try
    if Length(path) > 0 then
      pe := plist.FindFullPath(token)
    else
      pe := plist.FindEXEName(token);
    if (pe <> nil) then
    begin
      done := TerminateProcessID(pe^.th32ProcessID);
      if (not done) and nofail then
        ThrowError(': kill failed');
    end;
  finally
    plist.free;
  end;
end;
{$ENDIF}

function  DirectorysExist_F(
  sct: TJvRnnCustomScript; args : TStrings) : string; 
var
  i : integer;
begin
  Result := 'N';
  for i := 0 to args.count-1 do
  begin
    if not DirectoryExists(args[i]) then
      exit;
  end;
  Result := 'Y';
end;

function  FilesAllExist_F(sct: TJvRnnCustomScript; args : TStrings) : string;  {'N' or 'Y'}
var
  i : integer;
begin
  Result := 'N';
  for i := 0 to args.count-1 do
  begin
    if not FileExists(args[i]) then
      exit;
  end;
  Result := 'Y';
end;

procedure DosAttr_F(data:Pointer);
var
  cmdInfo : PJvScriptCmdInfo;
  p : PChar;
  token : string;
  ptype : TJvRnnParenType;
  toktype : TJvRnnTokenType;
  filename : string;
  oldattr : integer;
  attrbit : integer;
  attrmask_and : integer;
  attrmask_or : integer;

  procedure  throw_error(const instr : string);
  begin
    raise EJvDosCmd.create('DOS_SET_ATTRIBUTE: '+instr);
  end;

  function nextstr : boolean;
  begin
    Result := StrNextToken(p,token,ptype);
  end;

  function nextarg : boolean;
  begin
    Result := StrNextTokenType(p,token,ptype,toktype);
    end;

  function checkbit(sc:Char) : integer;
  begin
    result := GetFileAttrBitMask(sc);
    if result = 0 then
      throw_error('unknown option '+sc);
  end;

begin
  cmdInfo := PJvScriptCmdInfo(data);
  p := cmdInfo^.cmdcstr;
  attrmask_and := 0;
  attrmask_or := 0;
  oldattr := -1;
  while nextstr do
  begin
    if token[1] = '-' then
    begin
      attrbit := checkbit(token[2]);
      attrmask_and := attrmask_and or attrbit;
    end
    else if token[1] = '+' then
    begin
      attrbit := checkbit(token[2]);
      attrmask_or := attrmask_or or attrbit;
    end else
    begin
      if length(filename) <> 0 then
        throw_error('unknown option '+token);
      filename := token;
      oldattr := FileGetAttr(filename);
      if (oldattr = -1) then
        throw_error(filename + ' not found');
      end;
   end;
   {read filename, then a comma delimited list of attributes to set}
   if (oldattr = -1) then
     throw_error('no file path');
   attrbit := oldattr;
   if attrmask_or <> 0 then
     attrbit := attrbit or attrmask_or;
   if attrmask_and <> 0 then
     attrbit := attrbit and (not attrmask_and);
   if (attrbit <> oldattr) then
     FileSetAttr(filename,attrbit);

end;

procedure DosSetDateTime_F(data:Pointer);
const
  kFormatConst = 'format';
  kStampConst = 'stamp';
  kFileConst = 'file';
var
  cmdInfo : PJvScriptCmdInfo;
  p : PChar;
  token : string;
  ptype : TJvRnnParenType;
  toktype : TJvRnnTokenType;
  filename : string;
  i : integer;
  stub : string;

  procedure  throw_error(const instr : string);
  begin
    raise EJvDosCmd.create('DOS_DATETIME: '+instr);
  end;

  function nextstr : boolean;
  begin
    Result := StrNextToken(p,token,ptype);
  end;

  function nextarg : boolean;
  begin
    Result := StrNextTokenType(p,token,ptype,toktype);
  end;
begin
  cmdInfo := PJvScriptCmdInfo(data);
  p := cmdInfo^.cmdcstr;
  while not nextstr do
  begin
    i := Pos('==',token);
    if (i > 0) then
    begin
      stub := Copy(token,1,i-1);
      if length(stub) = 0 then
      begin
      end;
      if (COMPARETEXT(kFormatConst,Copy(token,1,i-1))=0) then
      begin
      end;
    end;
  end;
  throw_error('file name expected');
  filename := token;
end;


procedure InstallDOSCmds(scriptor:TJvRnnCustomScript);
begin
  with scriptor do
  begin
    SetUserOp(kDosCopy,@DosCopy_F);
    SetUserOp(kDosDel,@DosDel_F);
    SetUserOp(kDosRename, @DosRename_F);
    SetUserOp(kDosXCopy,@DosXCopy_F);
    SetUserOp(kDosDelTree,@DosDelTree_F);
    SetUserOp(kDosMkDir,@DosMkDir_F);
    SetUserOp(kDosRun,@DosRun_F);
    SetUserOp(kDosBatch,@DosBatch_F);
    SetUserOp(kDosDateTime,@DosSetDateTime_F);
    SetUserOp(kForFiles, @ForFiles_F);
    SetUserOp(kEndForFiles, @EndForFiles_F);
    SetUserOp(kDosAttr,@DosAttr_F);

    {$IFDEF PROCESSCTL}
    SetUserOp(kDosKill,@DosKill_F);
    SetUserOp(kDosWallpaper, @DosWallPaper_F);
    {$ENDIF}
    SetUserFunc(kDirectorysExist, @DirectorysExist_F);
    SetUserFunc(kFilesAllExist, @FilesAllExist_F);
  end;
end;

end.

